<?php

define('IN_COPPERMINE', true);
define('INDEX_PHP', true);

require('include/init.inc.php');

pageheader('Statistics');

starttable('1000px');

define('CAN_VIEW_ADS', GALLERY_ADMIN_MODE || USER_ID == 512);

if (CAN_VIEW_ADS){

echo <<< EOT

<tr>
	<td class="tableh1">Date</td>
	<td class="tableh1">Comments</td>
	<td class="tableh1">Pictures</td>
	<td class="tableh1">New members</td>
	<td class="tableh1">Views</td>
	<td class="tableh1">Ad revenue</td>
</tr>

EOT;

} else {

echo <<< EOT

<tr>
	<td class="tableh1">Date</td>
	<td class="tableh1">Comments</td>
	<td class="tableh1">Pictures</td>
	<td class="tableh1">New members</td>
	<td class="tableh1">Views</td>
</tr>

EOT;

}

$years = array();

$sql = "SELECT YEAR(msg_date) AS period, COUNT(*) AS number 
FROM cpg130_comments 
GROUP BY YEAR(msg_date) 
ORDER BY msg_date DESC";

$result = db_query($sql);
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['comments'] = $row['number'];
mysql_free_result($result);

$sql = "SELECT YEAR(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
FROM cpg130_pictures 
GROUP BY YEAR(FROM_UNIXTIME(ctime)) 
ORDER BY ctime DESC";

$result = db_query($sql);
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['pictures'] = $row['number'];
mysql_free_result($result);

$sql = "SELECT YEAR(user_regdate) AS period, COUNT(*) AS number 
FROM cpg130_users 
GROUP BY YEAR(user_regdate) 
ORDER BY user_regdate DESC";

$result = db_query($sql);		
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['users'] = $row['number'];
mysql_free_result($result);

$sql = "SELECT YEAR(hit_date) AS period, SUM(hit_count) AS number 
FROM cpg130_dailyhits 
GROUP BY YEAR(hit_date) 
ORDER BY hit_date DESC";

$result = db_query($sql);		
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['views'] = $row['number'];
mysql_free_result($result);

if (CAN_VIEW_ADS){

$sql = "SELECT YEAR(ad_date) AS period, SUM(ad_revenue) AS number 
FROM cpg130_ad_revenue
GROUP BY YEAR(ad_date) 
ORDER BY ad_date DESC";

$result = db_query($sql);		
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['ad_revenue'] = $row['number'];
mysql_free_result($result);
}

krsort($years);



function getbars($data){

	$max = array();
	//$total = array();
	
	foreach ($data as $period => $stats){
		foreach($stats as $param => $value){
			$max[$param] = max($max[$param], $value);
			//$total[$param] += $value;
		}
	}
	
	$bars = array();
	
	foreach ($data as $period => $stats){
		foreach($stats as $param => $value){
			$bars[$period][$param] = floor(($value / $max[$param]) * 100);
			if ($value) $bars[$period][$param] = max($bars[$period][$param], 1);
		}
	}
	
	return $bars;
}

$ybars = getbars($years);


foreach ($years as $year => $stats){
		
	makezeros($stats);
	makezeros($ybars[$year]);

	if (isset($_GET['year']) && $_GET['year'] == $year){
		$type = 'collapse';
		$y = '';
	} else {
		$type = 'expand';
		$y = "?year=$year";
	}
	
	if (CAN_VIEW_ADS){

	echo <<< EOT

<tr>
	<td class="tableb"><a href="stats.php$y"><img src="images/$type.gif" border="0">&nbsp;$year</a></td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['views']}">&nbsp;{$stats['views']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['ad_revenue']}">&nbsp;\${$stats['ad_revenue']}</td>
</tr>

EOT;
	
	} else {
	
	echo <<< EOT

<tr>
	<td class="tableb"><a href="stats.php$y"><img src="images/$type.gif" border="0">&nbsp;$year</a></td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$ybars[$year]['views']}">&nbsp;{$stats['views']}</td>
</tr>

EOT;

	}
	
	if (isset($_GET['year']) && $_GET['year'] == $year){
		
		$months = array();
			
		$sql = "SELECT MONTH(msg_date) AS period, COUNT(*) AS number 
		FROM cpg130_comments 
		WHERE YEAR(msg_date) = $year 
		GROUP BY MONTH(msg_date) 
		ORDER BY msg_date DESC";
		
		$result = db_query($sql);
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['comments'] = $row['number'];
		mysql_free_result($result);
		
		$sql = "SELECT MONTH(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
		FROM cpg130_pictures 
		WHERE YEAR(FROM_UNIXTIME(ctime)) = $year
		GROUP BY MONTH(FROM_UNIXTIME(ctime)) 
		ORDER BY ctime DESC";
		
		$result = db_query($sql);
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['pictures'] = $row['number'];
		mysql_free_result($result);
		
		$sql = "SELECT MONTH(user_regdate) AS period, COUNT(*) AS number 
		FROM cpg130_users 
		WHERE YEAR(user_regdate) = $year
		GROUP BY MONTH(user_regdate) 
		ORDER BY user_regdate DESC";
		
		$result = db_query($sql);		
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['users'] = $row['number'];
		mysql_free_result($result);

		$sql = "SELECT MONTH(hit_date) AS period, SUM(hit_count) AS number 
		FROM cpg130_dailyhits 
		WHERE YEAR(hit_date) = $year
		GROUP BY MONTH(hit_date) 
		ORDER BY hit_date DESC";
		
		$result = db_query($sql);		
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['views'] = $row['number'];
		mysql_free_result($result);
		
		if (CAN_VIEW_ADS){

		$sql = "SELECT MONTH(ad_date) AS period, SUM(ad_revenue) AS number 
		FROM cpg130_ad_revenue
		WHERE YEAR(ad_date) = $year
		GROUP BY MONTH(ad_date) 
		ORDER BY ad_date DESC";
		
		$result = db_query($sql);		
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['ad_revenue'] = $row['number'];
		mysql_free_result($result);
		
		}
					
		krsort($months);
		
		$mbars = getbars($months);
		
		foreach ($months as $month => $stats){

			makezeros($stats);
			makezeros($mbars[$month]);

			$monthname = date('F', strtotime("$month/01/$year"));
			
			if (isset($_GET['month']) && $_GET['month'] == $month){
				$type = 'collapse';
				$m = '';
			} else {
				$type = 'expand';
				$m = "&amp;month=$month";
			}
			
			if (CAN_VIEW_ADS){
			
			echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="stats.php?year=$year$m"><img src="images/$type.gif" border="0">&nbsp;$monthname</a></td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['views']}">&nbsp;{$stats['views']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['ad_revenue']}">&nbsp;\${$stats['ad_revenue']}</td>
</tr>

EOT;

			} else {
			
			echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="stats.php?year=$year$m"><img src="images/$type.gif" border="0">&nbsp;$monthname</a></td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$mbars[$month]['views']}">&nbsp;{$stats['views']}</td>
</tr>

EOT;
			
			
			}
			
			if (isset($_GET['month']) && $_GET['month'] == $month){
			
				$days = array();
				
				$sql = "SELECT DAY(msg_date) AS period, COUNT(*) AS number 
				FROM cpg130_comments 
				WHERE YEAR(msg_date) = $year 
				AND MONTH(msg_date) = $month
				GROUP BY DAY(msg_date) 
				ORDER BY msg_date DESC";
				
				$result = db_query($sql);
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['comments'] = $row['number'];
				mysql_free_result($result);
				
				$sql = "SELECT DAY(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
				FROM cpg130_pictures 
				WHERE YEAR(FROM_UNIXTIME(ctime)) = $year
				AND MONTH(FROM_UNIXTIME(ctime)) = $month
				GROUP BY DAY(FROM_UNIXTIME(ctime)) 
				ORDER BY ctime DESC";
				
				$result = db_query($sql);
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['pictures'] = $row['number'];
				mysql_free_result($result);
				
				$sql = "SELECT DAY(user_regdate) AS period, COUNT(*) AS number 
				FROM cpg130_users 
				WHERE YEAR(user_regdate) = $year
				AND MONTH(user_regdate) = $month
				GROUP BY DAY(user_regdate) 
				ORDER BY user_regdate DESC";
				
				$result = db_query($sql);		
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['users'] = $row['number'];
				mysql_free_result($result);

				$sql = "SELECT DAY(hit_date) AS period, SUM(hit_count) AS number 
				FROM cpg130_dailyhits 
				WHERE YEAR(hit_date) = $year
				AND MONTH(hit_date) = $month
				GROUP BY DAY(hit_date) 
				ORDER BY hit_date DESC";
				
				$result = db_query($sql);		
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['views'] = $row['number'];
				mysql_free_result($result);
				
				if (CAN_VIEW_ADS){

				$sql = "SELECT DAY(ad_date) AS period, SUM(ad_revenue) AS number 
				FROM cpg130_ad_revenue
				WHERE YEAR(ad_date) = $year
				AND MONTH(ad_date) = $month
				GROUP BY DAY(ad_date) 
				ORDER BY ad_date DESC";
				
				$result = db_query($sql);		
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['ad_revenue'] = $row['number'];
				mysql_free_result($result);				

				}
				
				krsort($days);
				
				$dbars = getbars($days);
				
				foreach ($days as $day => $stats){

					$dayname = date('Y-m-d', strtotime("$month/$day/$year"));
				
					makezeros($stats);
					makezeros($dbars[$day]);

					if (CAN_VIEW_ADS){

					echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$dayname</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['views']}">&nbsp;{$stats['views']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['ad_revenue']}">&nbsp;\${$stats['ad_revenue']}</td>
</tr>

EOT;

					} else {
					
					echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$dayname</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['users']}">&nbsp;{$stats['users']}</td>
	<td class="tableb"><img src="images/bar.gif" height="8" width="{$dbars[$day]['views']}">&nbsp;{$stats['views']}</td>
</tr>

EOT;
					
					}
				}
			}
		}
	}
}

endtable();

activityGraph("FROM_UNIXTIME(ctime)", $CONFIG['TABLE_PICTURES'], "Uploads", "images/bar.gif");
activityGraph("msg_date", $CONFIG['TABLE_COMMENTS'], "Comments", "images/bar.gif");
activityGraph("FROM_UNIXTIME(time)", 'cpg130_hits', "Views", "images/bar.gif");

pagefooter();

function makezeros(&$stats){

	$stats['comments'] = (int) $stats['comments'];
	$stats['pictures'] = (int) $stats['pictures'];
	$stats['users'] = (int) $stats['users'];
	$stats['views'] = (int) $stats['views'];
	if (empty($stats['ad_revenue'])) $stats['ad_revenue'] = 0;
}

//Activity Graph Function
function activityGraph($cellName, $tableName, $title, $barTile, $notCtime=false)
{
	global $CONFIG;
	starttable('100%', $title, 26);
	
	$query = "SELECT COUNT(*) AS number, HOUR($cellName) AS period FROM $tableName GROUP BY HOUR($cellName) ";
	$result = db_query($query);
	while ($row = mysql_fetch_assoc($result)) $rowset[$row['period']] = $row['number'];
	mysql_free_result($result);
	
	print('<tr><td align="center" colspan="26"><b>Time of Day</b></td></tr>');
	print('<tr><td align="center" colspan="26" height="2"></td></tr>');
	print('<tr><td align="center" colspan="26" height="2" bgcolor="#000000"></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td height="100" width="1" valign="bottom"><img src="images/spacer.gif" width="1" height="200" /></td>');
	
	$total = array_sum($rowset);
	$max = max($rowset);
	
	foreach ($rowset as $number)
	{
			print('<td height="100" width="4%" valign="bottom" align="center" style="font-size: 80%">'.round(($number/$total)*100,1).'%<br /><img src="'.$barTile.'" border="1" alt="" width="15" height="'.round(($number/$max)*200,0).'" /></td>');
	}
	print('<td height="100" width="1" valign="bottom"><img src="images/spacer.gif" width="1" height="200" /></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td align="center" colspan="26" height="2" bgcolor="#000000"></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td></td>');
	for($i = '0'; $i <= '23'; $i++)
	{
		print('<td width="4%" align="center">'.$i.'</td>');
	}
	print('<td></td></tr>');
	
	endtable();
	print('<img src="images/spacer.gif" alt="" height="17 width="1" />');
}
